using Exferia_Aplicacion.General;
using Exferia_KairosPRO_EF;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_KairosPRO._2_Datos
{
    public class KRS_EmpleadosFotos_Datos
    {
        private dynamic g_dnm_Modelo_Obtener = null;
        public dynamic Obtener(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                   " SELECT " +
                         nameof(KRS_EmpleadosFotos.id) + "," +
                         nameof(KRS_EmpleadosFotos.idEmpleado) + "," +
                         nameof(KRS_EmpleadosFotos.codigoCliente) + "," +
                         nameof(KRS_EmpleadosFotos.foto) + "," +
                         nameof(KRS_EmpleadosFotos.fechaActualizacion) + "," +
                         nameof(KRS_EmpleadosFotos.fechaBorrado) +
               " FROM " + nameof(KRS_EmpleadosFotos) +
               " WHERE " +
                            nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado and " +
                            nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_id),
                     new SqlParameter("@codigoCliente",  Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_KairosProEntities.Database.SqlQuery<KRS_EmpleadosFotos>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return g_dnm_Modelo_Obtener;
        }

        #region MODELOS

        #region Modelo Simple
        private KRS_EmpleadosFotos g_mdl_KRS_EmpleadosFotos = null;
        public KRS_EmpleadosFotos Obtener_Modelo_Por_Id(long _lng_id, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.id) + "=@id and " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_KRS_EmpleadosFotos;
        }

        public KRS_EmpleadosFotos Obtener_Modelo_Por_IdEmpleado(long _lng_idEmpleado, long _lng_CodigoCliente)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente",  _lng_CodigoCliente)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                            arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Obtener_Modelo_Por_IdEmpleado), true);
            }

            return g_mdl_KRS_EmpleadosFotos;
        }


        private void Ejecutar_Consulta_Modelo(string _str_SQL, object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;

            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el Modelo
                g_mdl_KRS_EmpleadosFotos = obj_KairosProEntities.Database.SqlQuery<KRS_EmpleadosFotos>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<KRS_EmpleadosFotos> g_lst_KRS_EmpleadosFotos = null;

        public List<KRS_EmpleadosFotos> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {
                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(KRS_EmpleadosFotos),
                                                                                           nameof(KRS_EmpleadosFotos.id),
                                                                                           G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                           _lst_Ids);


                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                       //WHERE
                                       " WHERE " +
                                           str_Filtros_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_KRS_EmpleadosFotos;
        }
        public List<KRS_EmpleadosFotos> Obtener_ModeloListado_Por_IdEmpleado(long _lng_idEmpleado,long _lng_CodigoCliente)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                    //WHERE
                                    " WHERE " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado and " +
                                        nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idEmpleado",  _lng_idEmpleado),
                     new SqlParameter("@codigoCliente", _lng_CodigoCliente )
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                    arr_Parametros);
                
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdEmpleado), true);
            }

            return g_lst_KRS_EmpleadosFotos;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                    object[] _arr_Parametros)
        {
            KairosProEntities obj_KairosProEntities = null;
            try
            {
                //Conexion
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_KRS_EmpleadosFotos = obj_KairosProEntities.Database.SqlQuery<KRS_EmpleadosFotos>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }
        }

        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.id) + " , " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.idEmpleado) + " , " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.codigoCliente) + " , " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.foto) + " , " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.fechaActualizacion) + " , " +
                    nameof(KRS_EmpleadosFotos) + "." + nameof(KRS_EmpleadosFotos.fechaBorrado) +
                " FROM " + nameof(KRS_EmpleadosFotos);
        }
        #endregion

        public INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj, long _lng_idEmpleado)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_KairosProEntities = new KairosProEntities();
                obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                KRS_EmpleadosFotos mdl_KRS_EmpleadosFotos_AGrabar = (KRS_EmpleadosFotos)_mdl_obj;
                KRS_EmpleadosFotos mdl_KRS_EmpleadosFotos_DatosViejos = new KRS_EmpleadosFotos();

                KRS_EmpleadosFotos mdl_KRS_EmpleadosFotos_Final = Obtener_Modelo_Por_IdEmpleado(_lng_idEmpleado, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);

                if (mdl_KRS_EmpleadosFotos_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Asignamos el id del objeto a modificar k al copiar las propiedades cambia a 0
                    mdl_KRS_EmpleadosFotos_AGrabar.id = mdl_KRS_EmpleadosFotos_Final.id;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_EmpleadosFotos_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Fecha utilizada para la sincronizar con la tablet, SIEMPRE PONERLA
                    mdl_KRS_EmpleadosFotos_AGrabar.fechaActualizacion = DateTime.Now;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_EmpleadosFotos_Final, mdl_KRS_EmpleadosFotos_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_EmpleadosFotos_AGrabar, mdl_KRS_EmpleadosFotos_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(KRS_EmpleadosFotos) +
                                           " SET " +
                                                nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado," +
                                                nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente," +
                                                nameof(KRS_EmpleadosFotos.foto) + "=@foto," +
                                                nameof(KRS_EmpleadosFotos.fechaActualizacion) + "=@fechaActualizacion," +
                                                nameof(KRS_EmpleadosFotos.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(KRS_EmpleadosFotos.id) + "=@id";

                    //Parametros
                    SqlParameter obj_SqlParameter_foto = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_KRS_EmpleadosFotos_Final.foto != null)
                    { obj_SqlParameter_foto.Value = mdl_KRS_EmpleadosFotos_Final.foto; }
                    else
                    { obj_SqlParameter_foto.Value = DBNull.Value; }

                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idEmpleado",  mdl_KRS_EmpleadosFotos_Final.idEmpleado),
                        new SqlParameter("@codigoCliente", mdl_KRS_EmpleadosFotos_Final.codigoCliente),
                        obj_SqlParameter_foto,
                        new SqlParameter("@fechaActualizacion", mdl_KRS_EmpleadosFotos_Final.fechaActualizacion),
                        mdl_KRS_EmpleadosFotos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_EmpleadosFotos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id", mdl_KRS_EmpleadosFotos_Final.id)
                    };
                    #endregion

                    //Update
                    obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_KRS_EmpleadosFotos_Final.id;


                }
                else
                {
                    mdl_KRS_EmpleadosFotos_Final = new KRS_EmpleadosFotos();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Validado el codigo del cliente, se lo asignamos antes de grabar
                    mdl_KRS_EmpleadosFotos_AGrabar.codigoCliente = Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO;

                    //Fecha utilizada para la sincronizar con la tablet, SIEMPRE PONERLA
                    mdl_KRS_EmpleadosFotos_AGrabar.fechaActualizacion = DateTime.Now;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_KRS_EmpleadosFotos_AGrabar, mdl_KRS_EmpleadosFotos_Final, false, false);


                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(KRS_EmpleadosFotos) +
                                               " (" +
                                                        nameof(KRS_EmpleadosFotos.idEmpleado) + "," +
                                                        nameof(KRS_EmpleadosFotos.codigoCliente) + "," +
                                                        nameof(KRS_EmpleadosFotos.foto) + "," +
                                                        nameof(KRS_EmpleadosFotos.fechaActualizacion) + "," +
                                                        nameof(KRS_EmpleadosFotos.fechaBorrado) +
                                               " ) " +
                                               " OUTPUT INSERTED." + nameof(KRS_EmpleadosFotos.id) +
                                               " VALUES " +
                                               " ( " +
                                                   "@idEmpleado," +
                                                   "@codigoCliente," +
                                                   "@foto," +
                                                   "@fechaActualizacion," +
                                                   "@fechaBorrado" +
                                               " ) ";

                    //Parametros
                    SqlParameter obj_SqlParameter_foto = new SqlParameter("@foto", SqlDbType.Binary);
                    if (mdl_KRS_EmpleadosFotos_Final.foto != null)
                    { obj_SqlParameter_foto.Value = mdl_KRS_EmpleadosFotos_Final.foto; }
                    else
                    { obj_SqlParameter_foto.Value = DBNull.Value; }

                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idEmpleado",  mdl_KRS_EmpleadosFotos_Final.idEmpleado),
                        new SqlParameter("@codigoCliente", mdl_KRS_EmpleadosFotos_Final.codigoCliente),
                        obj_SqlParameter_foto,
                        new SqlParameter("@fechaActualizacion", mdl_KRS_EmpleadosFotos_Final.fechaActualizacion),
                        mdl_KRS_EmpleadosFotos_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_KRS_EmpleadosFotos_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_KairosProEntities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_EmpleadosFotos), mdl_KRS_EmpleadosFotos_DatosViejos, mdl_KRS_EmpleadosFotos_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_KairosProEntities);
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                
                obj_KairosProEntities.Database.Connection.Close();
                obj_KairosProEntities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            KairosProEntities obj_KairosProEntities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            // Se utiliza la transaccion por la llamada al procedimiento de almacenado
            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {

                    //Primer Intento de Borrado
                    obj_KairosProEntities = new KairosProEntities();
                    obj_KairosProEntities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    KRS_EmpleadosFotos mdl_KRS_EmpleadosFotos = Obtener_Modelo_Por_IdEmpleado(_lng_id, Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO);
                    //######################################################################################

                    if (mdl_KRS_EmpleadosFotos != null )
                    {
                        //Se intenta borrar, si diera un error porque esta relacaionado se graba la fecha de baja
                        try
                        {
                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(KRS_EmpleadosFotos) +
                                                    " WHERE " +
                                                        nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado and " +
                                                        nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@idEmpleado", _lng_id),
                                 new SqlParameter("@codigoCliente", Variables.G_LNG_IDCLIENTE_LICENCIAVALIDADO)
                            };
                            #endregion

                            //Delete
                            obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                            USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_EmpleadosFotos), null, mdl_KRS_EmpleadosFotos, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_KairosProEntities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }
                    }
                    
                    // Actualizar la fecha de baja , al no poder borrarlo por tener relaciones
                    if (bol_ActualizarFechaBorrado)
                    {

                        #region Update
                        string str_SQL_Update = " UPDATE " + nameof(KRS_EmpleadosFotos) +
                                                    " SET " +
                                                    nameof(KRS_EmpleadosFotos.fechaBorrado) + "=@fechaBorrado " +
                                                " WHERE " +
                                                    nameof(KRS_EmpleadosFotos.idEmpleado) + "=@idEmpleado and " +
                                                    nameof(KRS_EmpleadosFotos.codigoCliente) + "=@codigoCliente ";
                        //Parametros
                        object[] arr_Parametros_Update = new object[]
                        {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@idEmpleado", _lng_id)
                        };
                        #endregion

                        //Update
                        obj_KairosProEntities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                        // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                        USR_Trazabilidad_Datos.Grabar_Trazabilidad(typeof(KRS_EmpleadosFotos), null, mdl_KRS_EmpleadosFotos, G_ENUM_TIPOACCION.INT_ELIMINAR, obj_KairosProEntities);
                    }

                    // Devolver también el Objeto
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
                    

                    // Se termina la Transaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(KRS_EmpleadosFotos_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    
                    obj_KairosProEntities.Database.Connection.Close();
                    obj_KairosProEntities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
    }
}
